# -*- coding: utf-8 -*-
#
# File: BPDElemento_ExportConfig.py
#
# Copyright (c) 2010 by Conselleria de Infraestructuras y Transporte de la
# Generalidad Valenciana
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
#
# Authors: 
# Conselleria de Infraestructuras y Transporte de la Generalidad Valenciana, Model Driven Development sl, Antonio Carrasco Valero
#
#

__author__ = """Conselleria de Infraestructuras y Transporte de la Generalidad Valenciana
<gvSIGbpd@gvSIG.org>, Model Driven Development sl <gvSIGbpd@ModelDD.org>,
Antonio Carrasco Valero <carrasco@ModelDD.org>"""

__docformat__ = 'plaintext'

from AccessControl                  import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.gvSIGbpd.config import *



class BPDElemento_ExportConfig:            

    """
    """
    security = ClassSecurityInfo()
    
    
    security.declarePublic('exportConfig')
    def exportConfig( self):
        return [
    {   'portal_types': [ 'BPDArtefacto', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'caracteristicas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesArtefactos',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionArtefactos', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'responsablesDeArtefacto',
                'related_types': [
                    {   'portal_types': [ 'BPDOrganizacion', 'BPDPerfil', 'BPDUnidadOrganizacional', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'herramientas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'entradasAProcesosDeNegocio',
                'related_types': [
                    {   'portal_types': [ 'BPDEntrada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'salidasDeProcesosDeNegocio',
                'related_types': [
                    {   'portal_types': [ 'BPDSalida', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'pasosQueRecibenElArtefacto',
                'related_types': [
                    {   'portal_types': [ 'BPDRecepcion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'pasosQueEnvianElArtefacto',
                'related_types': [
                    {   'portal_types': [ 'BPDEnvio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'politicasDeNegocioGobernantes',
                'related_types': [
                    {   'portal_types': [ 'BPDPoliticaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'reglasDeNegocioDirigentes',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'procesosGestores',
                'related_types': [
                    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelArtefacto',
                'related_types': [
                    {   'portal_types': [ 'BPDUsoArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'caracteristicasDelTipo',
                'related_types': [
                    {   'portal_types': [ 'BPDCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDCaracteristica', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'claseCaracteristica',
                'type': 'selection',
            },
            {   'name': 'multiplicidadMinima',
                'type': 'Number',
            },
            {   'name': 'restriccionTipo',
                'type': 'string',
            },
            {   'name': 'multiplicidadMaxima',
                'type': 'Number',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'relation_name': 'tiposDeArtefactos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'procesosGestores',
                'related_types': [
                    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDeLaCaracteristica',
                'related_types': [
                    {   'portal_types': [ 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDCasoDePrueba', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'datosDePrueba',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDDatosDePrueba', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesCasosDePrueba',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionCasosDePrueba', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'escenario',
                'related_types': [
                    {   'portal_types': [ 'BPDEscenario', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'listasDePruebas',
                'related_types': [
                    {   'portal_types': [ 'BPDListaDePruebas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDColeccionArtefactos', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'artefactos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDColeccionCasosDePrueba', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'casosDePrueba',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDCasoDePrueba', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDColeccionEntradas', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'entradas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDEntrada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDColeccionHerramientas', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'herramientas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDColeccionListasDePruebas', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'listasDePruebas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDListaDePruebas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDColeccionPasos', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'pasos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDColeccionPerfiles', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'perfiles',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPerfil', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDColeccionPoliticasDeNegocio', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'politicasDeNegocio',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPoliticaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDColeccionProcesosDeNegocio', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'procedimientos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDColeccionReglasDeNegocio', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'reglasDeNegocio',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDColeccionSalidas', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'salidas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDSalida', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDColeccionUnidadesOrganizacionales', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'unidadesOrganizacionales',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDOrganizacion', 'BPDUnidadOrganizacional', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDCondicion', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'condicion',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDDatosDePrueba', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'relation_name': 'elementosDeProceso',
                'related_types': [
                    {   'portal_types': [ 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDRecepcion', 'BPDSalida', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDDecision', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'esInicial',
                'type': 'Boolean',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'momentoDeReferenciaDeComienzo',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeComienzo',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeComienzo',
                'type': 'selection',
            },
            {   'name': 'momentoDeReferenciaDeFin',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeFin',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeFin',
                'type': 'selection',
            },
            {   'name': 'minimoEsfuerzoEstimado',
                'type': 'float',
            },
            {   'name': 'unidadMinimoEsfuerzoEstimado',
                'type': 'selection',
            },
            {   'name': 'maximoEsfuerzoEstimado',
                'type': 'float',
            },
            {   'name': 'unidadMaximoEsfuerzoEstimado',
                'type': 'selection',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosSiguientes',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosSiguientesEnCasoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoGestorExcepciones', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name': 'ejecutores',
                'related_types': [
                    {   'portal_types': [ 'BPDOrganizacion', 'BPDPerfil', 'BPDUnidadOrganizacional', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'reglasDeNegocioAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'herramientasAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosAnteriores',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosOriginandoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoGestorExcepciones', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'requeridoEnPlazos',
                'related_types':    [
                    {   'portal_types': [ 'BPDPlazo', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'aggregation_name':     'usosArtefactos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'usosCaracteristicas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'condiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'episodios',
                'related_types': [
                    {   'portal_types': [ ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDEntrada', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'esRequerida',
                'type': 'Boolean',
            },
            {   'name': 'multiplicidadMinima',
                'type': 'Number',
            },
            {   'name': 'multiplicidadMaxima',
                'type': 'Number',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fuenteDeInformacion',
                'type': 'Text',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'valorDefecto',
                'type': 'Text',
            },
        ],
        'traversals':   [
            {   'relation_name': 'artefactosDeEntrada',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'condiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'resolucionesDatos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDResolucionDatos', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'datosDePruebas',
                'related_types': [
                    {   'portal_types': [ 'BPDDatosDePrueba', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDEnvio', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'esInicial',
                'type': 'Boolean',
            },
            {   'name': 'multiplicidadMinima',
                'type': 'Number',
            },
            {   'name': 'multiplicidadMaxima',
                'type': 'Number',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'momentoDeReferenciaDeComienzo',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeComienzo',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeComienzo',
                'type': 'selection',
            },
            {   'name': 'momentoDeReferenciaDeFin',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeFin',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeFin',
                'type': 'selection',
            },
            {   'name': 'minimoEsfuerzoEstimado',
                'type': 'float',
            },
            {   'name': 'unidadMinimoEsfuerzoEstimado',
                'type': 'selection',
            },
            {   'name': 'maximoEsfuerzoEstimado',
                'type': 'float',
            },
            {   'name': 'unidadMaximoEsfuerzoEstimado',
                'type': 'selection',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'condiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'destinatarios',
                'related_types': [
                    {   'portal_types': [ 'BPDOrganizacion', 'BPDPerfil', 'BPDUnidadOrganizacional', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'artefactosEnviados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'resolucionesDatos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDResolucionDatos', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'recepciones',
                'related_types': [
                    {   'portal_types': [ 'BPDRecepcion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'datosDePruebas',
                'related_types': [
                    {   'portal_types': [ 'BPDDatosDePrueba', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosSiguientes',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosSiguientesEnCasoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoGestorExcepciones', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name': 'ejecutores',
                'related_types': [
                    {   'portal_types': [ 'BPDOrganizacion', 'BPDPerfil', 'BPDUnidadOrganizacional', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'reglasDeNegocioAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'herramientasAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosAnteriores',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosOriginandoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoGestorExcepciones', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'requeridoEnPlazos',
                'related_types':    [
                    {   'portal_types': [ 'BPDPlazo', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'aggregation_name':     'usosArtefactos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'usosCaracteristicas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'episodios',
                'related_types': [
                    {   'portal_types': [ ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDEscenario', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'episodios',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'resolucionesDatos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDResolucionDatos', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'casosDePrueba',
                'related_types': [
                    {   'portal_types': [ 'BPDCasoDePrueba', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'datosDePruebas',
                'related_types': [
                    {   'portal_types': [ 'BPDDatosDePrueba', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDExitoFinal', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'momentoDeReferenciaDeComienzo',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeComienzo',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeComienzo',
                'type': 'selection',
            },
            {   'name': 'momentoDeReferenciaDeFin',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeFin',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeFin',
                'type': 'selection',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'condiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosAnteriores',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosOriginandoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name': 'reglasDeNegocioAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'herramientasAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'usosArtefactos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'usosCaracteristicas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'episodios',
                'related_types': [
                    {   'portal_types': [ ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDExtensionProceso', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'condiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'puntosExtension',
                'related_types': [
                    {   'portal_types': [ 'BPDPuntoExtension', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDFracasoFinal', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'momentoDeReferenciaDeComienzo',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeComienzo',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeComienzo',
                'type': 'selection',
            },
            {   'name': 'momentoDeReferenciaDeFin',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeFin',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeFin',
                'type': 'selection',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'condiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosAnteriores',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosOriginandoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name': 'reglasDeNegocioAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'herramientasAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'usosArtefactos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'usosCaracteristicas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'episodios',
                'related_types': [
                    {   'portal_types': [ ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDHerramienta', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'coleccionesHerramientas',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionHerramientas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'instrucciones',
                'related_types': [
                    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'responsablesDeHerramienta',
                'related_types': [
                    {   'portal_types': [ 'BPDOrganizacion', 'BPDPerfil', 'BPDUnidadOrganizacional', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'artefactosDeHerramienta',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'procesosAsistidos',
                'related_types': [
                    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'pasosAsistidos',
                'related_types': [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'politicasDeNegocioGobernantes',
                'related_types': [
                    {   'portal_types': [ 'BPDPoliticaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'reglasDeNegocioDirigentes',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDListaDePruebas', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'relation_name': 'casosDePrueba',
                'related_types': [
                    {   'portal_types': [ 'BPDCasoDePrueba', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesListasDePruebas',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionListasDePruebas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDOrganizacion', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'abreviatura',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'responsabilidadesClave',
                'type': 'Text',
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'coleccionesPoliticasDeNegocio',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionPoliticasDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesReglasDeNegocio',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionReglasDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesUnidadesOrganizacionales',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionUnidadesOrganizacionales', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesPerfiles',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionPerfiles', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesProcesosDeNegocio',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionProcesosDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesArtefactos',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionArtefactos', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesHerramientas',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionHerramientas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'procesosSupervisados',
                'related_types': [
                    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'procesosEjecutados',
                'related_types': [
                    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'pasosEjecutados',
                'related_types': [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDPasoSimple', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'remitenteDeRecepciones',
                'related_types': [
                    {   'portal_types': [ 'BPDRecepcion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'destinatarioDeEnvios',
                'related_types': [
                    {   'portal_types': [ 'BPDEnvio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'responsableDeArtefactos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'responsableDeHerramientas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'politicasDeNegocioGobernantes',
                'related_types': [
                    {   'portal_types': [ 'BPDPoliticaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'reglasDeNegocioDirigentes',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesListasDePruebas',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionListasDePruebas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesCasosDePrueba',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionCasosDePrueba', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDPasoGestorExcepciones', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
        ],
        'traversals':   [
            {   'relation_name':    'pasosOriginandoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
        ],
    },
    {   'portal_types': [ 'BPDPasoSimple', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'esInicial',
                'type': 'Boolean',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'momentoDeReferenciaDeComienzo',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeComienzo',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeComienzo',
                'type': 'selection',
            },
            {   'name': 'momentoDeReferenciaDeFin',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeFin',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeFin',
                'type': 'selection',
            },
            {   'name': 'minimoEsfuerzoEstimado',
                'type': 'float',
            },
            {   'name': 'unidadMinimoEsfuerzoEstimado',
                'type': 'selection',
            },
            {   'name': 'maximoEsfuerzoEstimado',
                'type': 'float',
            },
            {   'name': 'unidadMaximoEsfuerzoEstimado',
                'type': 'selection',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'preCondiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPreCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'postCondiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPostCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosSiguientes',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosSiguientesEnCasoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoGestorExcepciones', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name': 'ejecutores',
                'related_types': [
                    {   'portal_types': [ 'BPDOrganizacion', 'BPDPerfil', 'BPDUnidadOrganizacional', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'reglasDeNegocioAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'herramientasAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosAnteriores',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosOriginandoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoGestorExcepciones', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'requeridoEnPlazos',
                'related_types':    [
                    {   'portal_types': [ 'BPDPlazo', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'aggregation_name':     'usosArtefactos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'usosCaracteristicas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'episodios',
                'related_types': [
                    {   'portal_types': [ ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDPerfil', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'abreviatura',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name': 'conocimientosPoseidos',
                'type': 'Text',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'habilidadesDemostradas',
                'type': 'Text',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'responsabilidadesClave',
                'type': 'Text',
            },
            {   'name': 'seleccionDePersonal',
                'type': 'Text',
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'relation_name': 'procesosSupervisados',
                'related_types': [
                    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'procesosEjecutados',
                'related_types': [
                    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'pasosEjecutados',
                'related_types': [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDPasoSimple', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'remitenteDeRecepciones',
                'related_types': [
                    {   'portal_types': [ 'BPDRecepcion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'destinatarioDeEnvios',
                'related_types': [
                    {   'portal_types': [ 'BPDEnvio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'responsableDeArtefactos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'responsableDeHerramientas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'politicasDeNegocioGobernantes',
                'related_types': [
                    {   'portal_types': [ 'BPDPoliticaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'reglasDeNegocioDirigentes',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDPlazo', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'esInicial',
                'type': 'Boolean',
            },
            {   'name': 'agotarPlazo',
                'type': 'Boolean',
            },
            {   'name': 'tiempoDeEspera',
                'type': 'Number',
            },
            {   'name': 'unidadDeTiempo',
                'type': 'selection',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'momentoDeReferenciaDeComienzo',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeComienzo',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeComienzo',
                'type': 'selection',
            },
            {   'name': 'momentoDeReferenciaDeFin',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeFin',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeFin',
                'type': 'selection',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'preCondiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPreCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'postCondiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPostCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosSiguientes',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosRequeridos',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDPasoSimple', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosSiguientesEnCasoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoGestorExcepciones', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name': 'reglasDeNegocioAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'herramientasAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosAnteriores',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosOriginandoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoGestorExcepciones', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'aggregation_name':     'usosArtefactos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'usosCaracteristicas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'episodios',
                'related_types': [
                    {   'portal_types': [ ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDPoliticaDeNegocio', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'coleccionesPoliticasDeNegocio',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionPoliticasDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'reglasDeNegocioDerivadas',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'procesosDeNegocioGobernados',
                'related_types': [
                    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'participantesGobernados',
                'related_types': [
                    {   'portal_types': [ 'BPDOrganizacion', 'BPDPerfil', 'BPDUnidadOrganizacional', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'herramientasGobernadas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'artefactosGobernados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDPostCondicion', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'condicion',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDPreCondicion', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'condicion',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'nivelDeAbstraccion',
                'type': 'selection',
            },
            {   'name': 'proposito',
                'type': 'Text',
            },
            {   'name': 'responsableMantenimiento',
                'type': 'string',
            },
            {   'name': 'seleccionDePersonal',
                'type': 'Text',
            },
            {   'name': 'esPlaneado',
                'type': 'Boolean',
            },
            {   'name': 'esContinuo',
                'type': 'Boolean',
            },
            {   'name': 'esRepetible',
                'type': 'Boolean',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name': 'version',
                'type': 'string',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'preCondiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPreCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'postCondiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPostCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesProcesosDeNegocio',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionProcesosDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'supervisor',
                'related_types': [
                    {   'portal_types': [ 'BPDOrganizacion', 'BPDPerfil', 'BPDUnidadOrganizacional', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'ejecutores',
                'related_types': [
                    {   'portal_types': [ 'BPDOrganizacion', 'BPDPerfil', 'BPDUnidadOrganizacional', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'extensiones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDExtensionProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesEntradas',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionEntradas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesSalidas',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionSalidas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesPasos',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionPasos', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'politicasDeNegocioGobernantes',
                'related_types': [
                    {   'portal_types': [ 'BPDPoliticaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'reglasDeNegocioDirigentes',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'herramientasDocumentadas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'artefactosGestionados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'caracteristicasGestionadas',
                'related_types': [
                    {   'portal_types': [ 'BPDCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'herramientasAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usadoComoSubProcesos',
                'related_types': [
                    {   'portal_types': [ 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'escenarios',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDEscenario', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDPrograma', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'tipoPrograma',
                'type': 'selection',
            },
            {   'name': 'fuentePrograma',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDPuntoExtension', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'esInicial',
                'type': 'Boolean',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'momentoDeReferenciaDeComienzo',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeComienzo',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeComienzo',
                'type': 'selection',
            },
            {   'name': 'momentoDeReferenciaDeFin',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeFin',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeFin',
                'type': 'selection',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'condiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'extensionesProcesos',
                'related_types': [
                    {   'portal_types': [ 'BPDExtensionProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosSiguientes',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosSiguientesEnCasoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoGestorExcepciones', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name': 'reglasDeNegocioAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'herramientasAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosAnteriores',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosOriginandoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoGestorExcepciones', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'aggregation_name':     'usosArtefactos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'usosCaracteristicas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'episodios',
                'related_types': [
                    {   'portal_types': [ ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDRecepcion', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'esInicial',
                'type': 'Boolean',
            },
            {   'name': 'momentoDeReferenciaDeComienzo',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeComienzo',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeComienzo',
                'type': 'selection',
            },
            {   'name': 'momentoDeReferenciaDeFin',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeFin',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeFin',
                'type': 'selection',
            },
            {   'name': 'minimoEsfuerzoEstimado',
                'type': 'float',
            },
            {   'name': 'unidadMinimoEsfuerzoEstimado',
                'type': 'selection',
            },
            {   'name': 'maximoEsfuerzoEstimado',
                'type': 'float',
            },
            {   'name': 'unidadMaximoEsfuerzoEstimado',
                'type': 'selection',
            },
            {   'name': 'condicion',
                'type': 'Text',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'multiplicidadMaxima',
                'type': 'Number',
            },
            {   'name': 'multiplicidadMinima',
                'type': 'Number',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'resolucionesDatos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDResolucionDatos', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'datosDePruebas',
                'related_types': [
                    {   'portal_types': [ 'BPDDatosDePrueba', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosSiguientes',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosSiguientesEnCasoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoGestorExcepciones', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name': 'ejecutores',
                'related_types': [
                    {   'portal_types': [ 'BPDOrganizacion', 'BPDPerfil', 'BPDUnidadOrganizacional', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'reglasDeNegocioAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'herramientasAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosAnteriores',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosOriginandoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoGestorExcepciones', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'requeridoEnPlazos',
                'related_types':    [
                    {   'portal_types': [ 'BPDPlazo', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'aggregation_name':     'usosArtefactos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'usosCaracteristicas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'artefactosRecibidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'condiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'envios',
                'related_types': [
                    {   'portal_types': [ 'BPDEnvio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'episodios',
                'related_types': [
                    {   'portal_types': [ ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'remitente',
                'related_types': [
                    {   'portal_types': [ 'BPDOrganizacion', 'BPDPerfil', 'BPDUnidadOrganizacional', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDReferenciaCualificada', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidosCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDReglaDeNegocio', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'coleccionesReglasDeNegocio',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionReglasDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'politicasDeNegocioBase',
                'related_types': [
                    {   'portal_types': [ 'BPDPoliticaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'procesosDeNegocioDirigidos',
                'related_types': [
                    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'pasosAplicandoLaRegla',
                'related_types': [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'participantesDirigidos',
                'related_types': [
                    {   'portal_types': [ 'BPDOrganizacion', 'BPDPerfil', 'BPDUnidadOrganizacional', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'artefactosDirigidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'herramientasDirigidas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDResolucionDatos', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'tipoPrograma',
                'type': 'selection',
            },
            {   'name': 'fuentePrograma',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDSalida', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'esRequerida',
                'type': 'Boolean',
            },
            {   'name': 'multiplicidadMinima',
                'type': 'Number',
            },
            {   'name': 'multiplicidadMaxima',
                'type': 'Number',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'artefactosDeSalida',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'condiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'resolucionesDatos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDResolucionDatos', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'datosDePruebas',
                'related_types': [
                    {   'portal_types': [ 'BPDDatosDePrueba', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDSubProceso', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'esInicial',
                'type': 'Boolean',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'momentoDeReferenciaDeComienzo',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeComienzo',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeComienzo',
                'type': 'selection',
            },
            {   'name': 'momentoDeReferenciaDeFin',
                'type': 'selection',
            },
            {   'name': 'desplazamientoMomentoDeFin',
                'type': 'float',
            },
            {   'name': 'unidadMomentoDeFin',
                'type': 'selection',
            },
            {   'name': 'minimoEsfuerzoEstimado',
                'type': 'float',
            },
            {   'name': 'unidadMinimoEsfuerzoEstimado',
                'type': 'selection',
            },
            {   'name': 'maximoEsfuerzoEstimado',
                'type': 'float',
            },
            {   'name': 'unidadMaximoEsfuerzoEstimado',
                'type': 'selection',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'preCondiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPreCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'postCondiciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPostCondicion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'programas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDPrograma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'procesoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosSiguientes',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosSiguientesEnCasoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoGestorExcepciones', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name': 'ejecutores',
                'related_types': [
                    {   'portal_types': [ 'BPDOrganizacion', 'BPDPerfil', 'BPDUnidadOrganizacional', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'reglasDeNegocioAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'herramientasAplicadas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':    'pasosAnteriores',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'pasosOriginandoExcepcion',
                'related_types':    [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDExitoFinal', 'BPDFracasoFinal', 'BPDPasoGestorExcepciones', 'BPDPasoSimple', 'BPDPlazo', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'relation_name':    'requeridoEnPlazos',
                'related_types':    [
                    {   'portal_types': [ 'BPDPlazo', ],
                        'reuse_config': 'Default',
                    },
                ],
                'candidates_scope': 'Owner',
            },
            {   'aggregation_name':     'usosArtefactos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'usosCaracteristicas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'episodios',
                'related_types': [
                    {   'portal_types': [ ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDUnidadOrganizacional', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'abreviatura',
                'type': 'string',
            },
            {   'name': 'codigo',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'estado',
                'type': 'selection',
            },
            {   'name': 'fechaAdopcion',
                'type': 'Date',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name': 'fechaObsolescencia',
                'type': 'Date',
            },
            {   'name': 'nivelDeImposicion',
                'type': 'selection',
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'responsabilidadesClave',
                'type': 'Text',
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name': 'version',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'coleccionesUnidadesOrganizacionales',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionUnidadesOrganizacionales', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesPerfiles',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionPerfiles', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'procesosSupervisados',
                'related_types': [
                    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'procesosEjecutados',
                'related_types': [
                    {   'portal_types': [ 'BPDProcesoDeNegocioSimple', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'pasosEjecutados',
                'related_types': [
                    {   'portal_types': [ 'BPDDecision', 'BPDEnvio', 'BPDPasoSimple', 'BPDRecepcion', 'BPDSubProceso', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'remitenteDeRecepciones',
                'related_types': [
                    {   'portal_types': [ 'BPDRecepcion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'destinatarioDeEnvios',
                'related_types': [
                    {   'portal_types': [ 'BPDEnvio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'responsableDeArtefactos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'responsableDeHerramientas',
                'related_types': [
                    {   'portal_types': [ 'BPDHerramienta', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'politicasDeNegocioGobernantes',
                'related_types': [
                    {   'portal_types': [ 'BPDPoliticaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'reglasDeNegocioDirigentes',
                'related_types': [
                    {   'portal_types': [ 'BPDReglaDeNegocio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesListasDePruebas',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionListasDePruebas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionesCasosDePrueba',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDColeccionCasosDePrueba', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDUsoArtefacto', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'esRequerido',
                'type': 'Boolean',
            },
            {   'name': 'modoDeUso',
                'type': 'selection',
            },
            {   'name': 'multiplicidadMinima',
                'type': 'Number',
            },
            {   'name': 'multiplicidadMaxima',
                'type': 'Number',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'artefactosUsados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'resolucionesDatos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDResolucionDatos', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'datosDePruebas',
                'related_types': [
                    {   'portal_types': [ 'BPDDatosDePrueba', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'BPDUsoCaracteristica', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'esRequerida',
                'type': 'Boolean',
            },
            {   'name': 'modoDeUso',
                'type': 'selection',
            },
            {   'name': 'multiplicidadMinima',
                'type': 'Number',
            },
            {   'name': 'multiplicidadMaxima',
                'type': 'Number',
            },
            {   'name': 'codigoIdiomaInterno',
                'type': 'string',
            },
            {   'name': 'camposPendientesTraduccionInterna',
                'type': 'string',
            },
            {   'name': 'camposPendientesRevisionInterna',
                'type': 'string',
            },
            {   'name':                'contadorCambios',
                'type':                'Number',
                'is_activity_counter': True,
            },
            {   'name':                'contadoresDeFuentes',
                'type':                'string',
                'is_activity_counter': True,
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name':             'fechaCreacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaEliminacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':             'fechaModificacion',
                'type':             'Date',
                'is_activity_date': True,
            },
            {   'name':                'registroDeCambios',
                'type':                'Text',
                'is_activity_counter': True,
            },
            {   'name': 'uidInterTraduccionesInterno',
                'type': 'string',
            },
            {   'name':             'uidInterVersionesInterno',
                'type':             'string',
                'is_inter_version': True,
            },
            {   'name':             'usuarioCreador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioEliminador',
                'type':             'string',
                'is_activity_user': True,
            },
            {   'name':             'usuarioModificador',
                'type':             'string',
                'is_activity_user': True,
            },
        ],
        'traversals':   [
            {   'relation_name': 'caracteristicasUsadas',
                'related_types': [
                    {   'portal_types': [ 'BPDCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'resolucionesDatos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDResolucionDatos', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'datosDePruebas',
                'related_types': [
                    {   'portal_types': [ 'BPDDatosDePrueba', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referidos',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentes',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'referenciasCualificadas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'referentesCualificados',
                'related_types': [
                    {   'portal_types': [ 'BPDReferenciaCualificada', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosBase',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosDerivados',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementoUsado',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'usosDelElemento',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosOriginales',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'elementosCopia',
                'related_types': [
                    {   'portal_types': [ 'BPDArtefacto', 'BPDCaracteristica', 'BPDCasoDePrueba', 'BPDColeccionArtefactos', 'BPDColeccionCasosDePrueba', 'BPDColeccionEntradas', 'BPDColeccionHerramientas', 'BPDColeccionListasDePruebas', 'BPDColeccionPasos', 'BPDColeccionPerfiles', 'BPDColeccionPoliticasDeNegocio', 'BPDColeccionProcesosDeNegocio', 'BPDColeccionReglasDeNegocio', 'BPDColeccionSalidas', 'BPDColeccionUnidadesOrganizacionales', 'BPDCondicion', 'BPDDatosDePrueba', 'BPDDecision', 'BPDEntrada', 'BPDEnvio', 'BPDEscenario', 'BPDExitoFinal', 'BPDExtensionProceso', 'BPDFracasoFinal', 'BPDHerramienta', 'BPDListaDePruebas', 'BPDOrganizacion', 'BPDPasoSimple', 'BPDPerfil', 'BPDPlazo', 'BPDPoliticaDeNegocio', 'BPDPostCondicion', 'BPDPreCondicion', 'BPDProcesoDeNegocioSimple', 'BPDPrograma', 'BPDPuntoExtension', 'BPDRecepcion', 'BPDReferenciaCualificada', 'BPDReglaDeNegocio', 'BPDResolucionDatos', 'BPDSalida', 'BPDSubProceso', 'BPDUnidadOrganizacional', 'BPDUsoArtefacto', 'BPDUsoCaracteristica', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'archivos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATFile', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'documentos',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATDocument', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'enlaces',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATLink', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATImage', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'noticias',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'ATNewsItem', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
]
